#include <bits/stdc++.h>
#define ll long long
#define si short int

using namespace std;
int main(void)
{
    int n,k;
    cin>>n>>k;
    int a[n+2][2];
    for(int i=0;i<n+2;i++)
        a[i][0]=0, //za manje od 0
        a[i][1]=0; //za vece od nule
    int brc=0;
    vector<int> resenja;
    for(int i=0;i<n;i++)
    {
        int x;
        cin>>x;
        if(x>=0)
        {
            if(a[x][1]!=-1)
            {
                a[x][1]++;
                if(a[x][1]>=k)
                {
                    cout<<x<<endl;
                    resenja.push_back(x);
                    a[x][1]=-1;
                }
            }
        }
        else
        {
            x=abs(x);
            if(a[x][0]!=-1)
            {
                a[x][0]++;
                if(a[x][0]>=k)
                {
                    cout<<-x<<endl;
                    resenja.push_back(-x);
                    a[x][0]=-1;
                }
            }
        }
    }
    cout<<resenja.size()<<endl;
    for(int i=0;i<resenja.size();i++)
        cout<<resenja[i]<<' ';
}